  
/* Original source code by Compilerware with tabs = 3 */

#ifndef cParser_H
#define cParser_H

/////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                 //
//    PARSER.H

/*    Generated by: LRSTAR 4.0.018
      Grammar:      lr1.grm
      Skeleton:     ..\..\skl\parser.h.skl
      Output:       lr1_parser.h
*/               
		#include "stdio.h"
		#include "lr1_lexer.h"

		#define EOF_CHAR  26 // End Of File character.                    


		class Symbol             
		{
		public:
			char*  name;	 // Pointer to symbol name.														4		
			short  length;	 // Length  of symbol name.														2
			short  level;	 // Level number for scope.                                        	2
			ushort term;	 // Terminal number (e.g. <identifier>, <string>, {typedef}, ...)		2
         ushort type;	 // Type (e.g. integer, float, double, char, ...)							2
			int    cell;	 // Hash vector cell number for deleting this symbol.						4  16 bytes
		};

		class Symtab 
		{
		public:
			static Symbol*  symbol;			// Symbols.
			static int      n_symbols;		// Number of symbols.
			static int      n_keywords;	// Number of keywords in symbol table.
			static short    length;			// Current length of symbol name.
			static int      cell;			// Current hash cell number.
			static int      sti;				// Current symbol-table index.
			static ulong    hashdiv;		// Hash divisor. 
			static int*     hashvec;		// Hash vector.
			static int      max_symbols;	// Maximum number of symbols.
			static int      max_cells;    // Maximum number of cells in the hash vector. 
		};

		class Node                
		{
		public:
			ushort id;		 // Node id number    (65535 max).					2	 2	
			ushort prod;	 // Production number (65535 max).					2	 4	
			int    sti;     // Symbol-table index (perm or temp var).		4	 8
			int    prev;	 // Previous node.			   						4  12
			int    next;	 // Next node.												4  16
			int    line;    // Line number.                                4  20 
			int    child;   // Child node.                                	4  24 
			int    parent;  // Parent node.                             	4  28 bytes per node
		}; 
  
      class Stack
      {
         public:
         ushort id;      // Node id.                      2	 2	
         ushort counter; // Counter of node accesses.     2	 4	
      };

		class AST 
		{
			public:	
			static char     indent[256];	// Indentation for printing current node.
         static ushort*  counter;		// Node counter array.
         static short    stacki;			// AST stack index.
         static Stack*   stack;			// AST stack array.
			static Node*    node;			// AST node array.
			static int      root;			// Root node number.
			static int      n_nodes;		// Number of nodes.
			static int      max_nodes;		// Maximum number of nodes.
		};

	// AST Action Mode. 
      #define TOP_DOWN   0	 // Top down status.  
   	#define PASS_OVER  1  // Pass over status.
   	#define BOTTOM_UP  2  // Bottom up status.  
   
      class PStack // Parser stack.
      {
         public:
         int    state;	 // Parser state.                 4	 4	
         int    sti;     // Symbol table index.           4	 8	
         int    line;    // Input line number.            4	12	
         int    node;    // Node number.                  4	16	
         int    last;    // Last in list number.          4	20	bytes per cell.
			int    sym;     // Symbol stacked, terminal (positive) or nonterminal (negative). 
      };

      class RStack // Restore Stack.
      {
         public:
         PStack* ptr;	 // Parse stack pointer.			4	4	
         int     state;  // State.								4	8	bytes.
      };

      class lr1_parser : public lr1_lexer, public Symtab, public AST
		{
		public:

			static int   init(char*, FILE*, int, int);	// Parser initialization.
			static void  term();									// Parser termination.

			static int   parse      (char* input_start);	
			static void  parse_term ();	
			static int   add_symbol (short, char*, char*);
			static int   get_symbol (char*, char*); 
			static short emitstr	   (int n, char* str);

			static short    status;					// Status for parser actions and AST actions.
			static char*    inputname;				// Input file name.
			static FILE*    outputdesc;			// Output file desc.
         static PStack*  PS;           		// Parse Stack pointer.       
         static PStack*  PS_end;         		// Parse Stack end.       
         static int*     SS;           		// State Stack pointer.       
         static int*     SS_end;         		// State Stack end.       

			static char     tact_arg[];	// Token action argument index (for first arg).
			static char     pact_arg[];	// Production action argument index (for first arg).
			static char     node_arg[];	// Node argument index (for first arg).
			static char     nact_arg[];	// Node action argument index (for first arg).
			static int      arg_numb[];		
			// Parse argument numbers.
			static char*    arg_text[];			// Argument text (if a string argument or node arg).
			static char*    symbol_name (int);

		private:

			static int      n_errors;				// Number of errors.
			static int      n_lines;				// Number of lines read.
			static int      max_errs;				// Maximum allowable errors.
			static ushort   n_terms;				// Number of terminal symbols in grammar.
			static ushort   n_heads;				// Number of head symbols in grammar.
			static ushort   n_prods;				// Number of productions (rules) in grammar.
			static ushort   n_states;				// Number of states in parser state machine.
			static ushort   eof_symb;				// <eof> symbol number.
			static ushort   eol_symb;				// <eol> symbol number.
			static ushort   err_used;				// <error> used in grammar?
                                       		                                   
         static RStack*  RS;           		// Reduction Stack pointer.
			static ushort   n_nodenames;			// Number of node names in grammar.
			static ushort   n_nodeactns;			// Number of node processors (AST actions).
			static char*    node_name[];			// Node names array.

			static char*    T_list;					// Terminal symbol list (0 or 1).
			static int*     P_list;					// Production list.
         static RStack   R_stack[];				// Reduction stack.
         static PStack   P_stack[];				// Parser stack.
         static int      S_stack[];				// State stack.
			static PStack*  PStop;				   // Top pointer for parser stack.
			static int      topstate;				// Top state (before reductions start).

			static char     nact_numb[];  // Node action numbers.
			static char*    term_symb[];  // Terminal symbols of the grammar.
			static char*    head_symb[];  // Head (nonterminal) symbols of the grammar.
			static uchar    head_numb[];  // Head symbol number for a production (rule).
			static char     PL[];			// Production (rule) length less one (zero based).
			static char     tact_numb[];  // Token action number. 
			static char     pact_numb[];  // Production action number (for a parser action).
			static char     node_numb[];  // Node number index for a production (rule).

			static uchar    Bm[];			// Bit matrix (0 or 1).
			static uchar    Br[];			// Bit matrix row (base).
			static uchar    Bc[];			// Bit matrix column (displacement).
			static uchar    Bmask[];		// Bit matrix mask.
			static char     Tm[];			// Terminal transition matrix (gives next state or reduction).
			static uchar    Tr[];			// Terminal transition matrix row (base).
			static uchar    Tc[];			// Terminal transition matrix column (displacement).
			static char     Nm[];			// Nonterminal transition matrix (gives next state or reduction).
			static uchar    Nr[];			// Nonterminal transition matrix row (base).
			static uchar    Nc[];			// Nonterminal transition matrix column (displacement).
			static uchar    Rm[];			// Reduction matrix (gives reduction).
			static uchar    Rr[];			// Reduction matrix row (base).
			static uchar    Rc[];			// Reduction matrix column (displacement).
			static uchar    reverse[];		// Reverse order of nodes for this production (rule)?
			static uchar    f_tail[];		// First tail symbol for a production.
			static char     tail[];			// Tail symbols for productions.

			static uchar    nd_start[];
			static uchar    nd_term[]; 
			static char     nd_action[]; 

		// Parser functions
			static int    nd_parse     (int*, int*, int*, int x, int t, int a);
			static int    reduce_action(int p);
			static int    linkup			(int p);
			static void   rebuild		();                           
			static void   prt_help		();
			static short  err_rec		(short, short);
			static short  lookahead		(short t, short x);
			static void   get_list		(short);
			static void   prt_error		(char*);
			static void   prt_prod		(short); 
			static void   prt_stack		(); 
			static void   expecting		(); 
			static void	  collect		(int x);
			static void	  reduce			(int p, int x);
			static void   prt_list     (int t);

		// Symtab functions
			static int    init_symtab  (int);	// Initialize the symbol table.
			static void   term_symtab  ();		// Initialize the symbol table.
			static void   print_symtab (char**);
         static void   prt_line     ();

		// AST functions
			static int    init_ast		(int);
			static void   term_ast		();
			static void   print_ast		();
			static void   print_ast		(int n);
			static void   print_node	(char *indent, int n);
         static void   traverse		();
         static void   traverse		(int n);
			static void   traverse		(char *indent, int n);
		};

#endif

